% FEEC/Unicamp
% 28/05/2017
% Verification of the training performance: activation functions
% Use of weights obtained after training
%
clear;
close all;
load vw;load vv;load vc;load vbias;
load data;
[m,n] = size(v);
[N,r] = size(S);
P = length(c(1,:));
disp('Number of training patterns');
disp(N);
disp('Number of neuron in the hidden layer');
disp(n);
disp('Order of the Hermite polynomials');
disp(P);
for a=1:n,
	figure(a);
	Srn = zeros(N,r);
	for b=1:n,
		if b ~= a,
			Srn = Srn + factiv(X*v(:,b),c(b,:))*w(b,:);
			for k=1:r,
				Srn(:,k) = Srn(:,k)+bias(b,k);
			end
		end
	end
	D = S-Srn;
	Sa = factiv(X*v(:,a),c(a,:))*w(a,:);
	for k=1:r,
		Sa(:,k) = Sa(:,k)+bias(a,k);
		subplot(r,1,k);
		y = Sa(:,k);z = D(:,k)/norm(D(:,k));
		beta = 100*(y'*z)^2/(y'*y);
		plot(X*v(:,a),D(:,k),'*g');hold on;[xs,ind] = sort(X*v(:,a));plot(xs,y(ind),'r');
		if r > 1,
			title(sprintf('Neuron %d / Output %d / %g %%',a,k,beta));
		else
			title(sprintf('Neuron %d / %g %%',a,beta));
		end
		drawnow;hold off;
	end
end
